!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
      SUBROUTINE WRITE_DIAG_MISC_TEB_n(HPROGRAM,KTEB_PATCH)
!     #################################
!
!!****  *WRITE_DIAG_MISC_TEB* - writes the TEB diagnostic fields
!!
!!    PURPOSE
!!    -------
!!
!!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!	P. Le Moigne   *Meteo France*	
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    10/2004
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
USE MODI_INIT_IO_SURF_n
USE MODI_WRITE_SURF
USE MODI_END_IO_SURF_n
USE MODD_TEB_n,ONLY : XZ0_TOWN, NTEB_PATCH, CBEM, XROAD, LGREENROOF, LGARDEN, CWALL_OPT
USE MODD_DIAG_MISC_TEB_n,ONLY : LSURF_MISC_BUDGET,                               &
                                  XQF_BLD,XFLX_BLD, XQF_TOWN, XDQS_TOWN,         &
                                  XRN_ROAD, XH_ROAD, XLE_ROAD, XGFLUX_ROAD,      &
                                  XRN_WALL_A, XH_WALL_A, XGFLUX_WALL_A,          &
                                  XRN_WALL_B, XH_WALL_B, XGFLUX_WALL_B,          &
                                  XRN_ROOF, XH_ROOF, XLE_ROOF, XGFLUX_ROOF,      &
                                  XRN_GARDEN,XH_GARDEN,XLE_GARDEN,XGFLUX_GARDEN, &
                                  XRN_BLT,XH_BLT,XLE_BLT,XGFLUX_BLT,             &
                                  XABS_SW_ROOF ,XABS_SW_SNOW_ROOF,               &
                                  XABS_LW_ROOF ,XABS_LW_SNOW_ROOF,               &
                                  XABS_SW_ROAD ,XABS_SW_SNOW_ROAD,               &
                                  XABS_LW_ROAD ,XABS_LW_SNOW_ROAD,               &
                                  XABS_SW_WALL_A , XABS_LW_WALL_A,               &
                                  XABS_SW_WALL_B , XABS_LW_WALL_B,               &
                                  XABS_SW_GARDEN, XABS_LW_GARDEN,                &
                                  XH_BLD_COOL, XT_BLD_COOL,                      &     
                                  XH_BLD_HEAT, XLE_BLD_COOL, XLE_BLD_HEAT,       &
                                  XH_WASTE, XLE_WASTE, XHVAC_COOL,               &
                                  XHVAC_HEAT, XCAP_SYS, XM_SYS, XCOP,            &
                                  XQ_SYS, XT_SYS, XTR_SW_WIN, XFAN_POWER,        &
                                  XABS_SW_WIN, XABS_LW_WIN, XEMIT_LW_FAC,        &
                                  XEMIT_LW_GRND, XT_RAD_IND, XREF_SW_GRND,       &
                                  XREF_SW_FAC, XHU_BLD,                          &
                                  XRN_STRLROOF,XH_STRLROOF,XLE_STRLROOF,         &
                                  XGFLUX_STRLROOF,                               &
                                  XRN_GREENROOF,XH_GREENROOF,XLE_GREENROOF,      &
                                  XGFLUX_GREENROOF,                              &
                                  XABS_SW_GREENROOF, XABS_LW_GREENROOF,          &  
                                  XG_GREENROOF_ROOF,                             &
                                  XRUNOFF_GREENROOF, XDRAIN_GREENROOF
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
!
 CHARACTER(LEN=6),  INTENT(IN)  :: HPROGRAM   ! program calling
INTEGER,           INTENT(IN)  :: KTEB_PATCH ! patch number being written
!
!*       0.2   Declarations of local variables
!              -------------------------------
!
INTEGER           :: IRESP          ! IRESP  : return-code if a problem appears
 CHARACTER(LEN=3)  :: YPATCH         ! Prefix for current patch
 CHARACTER(LEN=12) :: YRECFM         ! Name of the article to be read
 CHARACTER(LEN=100):: YCOMMENT       ! Comment string
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!-------------------------------------------------------------------------------
!
!         Initialisation for IO
!
IF (LHOOK) CALL DR_HOOK('WRITE_DIAG_MISC_TEB_N',0,ZHOOK_HANDLE)
 CALL INIT_IO_SURF_n(HPROGRAM,'TOWN  ','TEB   ','WRITE')
!
YPATCH = '   '
IF (NTEB_PATCH>1) WRITE(YPATCH,FMT='(A,I1,A)') 'T',KTEB_PATCH,'_'
!-------------------------------------------------------------------------------
!
IF (LSURF_MISC_BUDGET) THEN
!
!*       Miscellaneous fields :
!        ----------------------
!
YRECFM='D_RD'
YCOMMENT='Road fraction'
 CALL WRITE_SURF(HPROGRAM,YRECFM,XROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='Z0_TOWN'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='town roughness length'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XZ0_TOWN(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='XQF_BLD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='domestic heating'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XQF_BLD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='XQF_TOWN'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='total anthropogenic heat'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XQF_TOWN(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='XDQS_TOWN'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='heat storage inside building'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XDQS_TOWN(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='RN_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT=' net radiation at road'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='H_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='road sensible heat flux'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XH_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LE_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='road latent heat flux'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='GFLUX_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='net road conduction flux'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
IF (CWALL_OPT=='UNIF') THEN
  !
  YRECFM='RN_WL'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net radiation for wall '//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='H_WL'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='wall sensible heat flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XH_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='GFLUX_WL'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net wall conduction flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
ELSE
  !
  YRECFM='RN_WLA'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net radiation for wall A'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='H_WLA'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='wall A sensible heat flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XH_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='GFLUX_WLA'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net wall A conduction flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='RN_WLB'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net radiation for wall B'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_WALL_B(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='H_WLB'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='wall B sensible heat flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XH_WALL_B(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='GFLUX_WLB'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net wall B conduction flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_WALL_B(:),IRESP,HCOMMENT=YCOMMENT)
  !
ENDIF
!
YRECFM='RN_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='net radiation for roof'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='H_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='roof sensible heat flux'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XH_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LE_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='roof latent heat flux'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='GFLUX_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='net roof conduction flux'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
IF (LGARDEN) THEN
  !
  YRECFM='RN_GD'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net radiation for GARDEN areas'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_GARDEN(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='H_GD'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='GARDEN area sensible heat flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XH_GARDEN(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='LE_GD'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='GARDEN area latent heat flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_GARDEN(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='GFLUX_GD'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='net GARDEN area conduction flux'//YRECFM//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_GARDEN(:),IRESP,HCOMMENT=YCOMMENT)
  !
ENDIF
!
YRECFM='RN_BLT'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='net radiation for built surfaces'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_BLT(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='H_BLT'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='built surface sensible heat flux'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XH_BLT(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LE_BLT'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='built surface latent heat flux'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_BLT(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='GFLUX_BLT'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='built surface conduction flux'//YRECFM//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_BLT(:),IRESP,HCOMMENT=YCOMMENT)
!
!
YRECFM='SWA_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Sdown absorbed by roofs'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='SWA_SN_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Sdown absorbed by snow on roofs'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_SNOW_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LWA_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Ldown absorbed by roofs'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LWA_SN_RF'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Ldown absorbed by snow on roofs'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_SNOW_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='SWA_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Sdown absorbed by roads'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='SWA_SN_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Sdown absorbed by snow on roads'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_SNOW_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LWA_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Ldown absorbed by roads'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LWA_SN_RD'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Ldown absorbed by snow on roads'//' (W/m2)'
!
 CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_SNOW_ROAD(:),IRESP,HCOMMENT=YCOMMENT)
!
IF (CWALL_OPT=='UNIF') THEN
  !
  YRECFM='SWA_WL'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Sdown absorbed by wall'//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='LWA_WL'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Ldown absorbed by wall '//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
ELSE
  !
  YRECFM='SWA_WLA'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Sdown absorbed by wall A'//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='LWA_WLA'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Ldown absorbed by wall A'//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_WALL_A(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='SWA_WLB'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Sdown absorbed by wall B'//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_WALL_B(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='LWA_WLB'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Ldown absorbed by wall B'//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_WALL_B(:),IRESP,HCOMMENT=YCOMMENT)
  !
ENDIF
!
IF (LGARDEN) THEN
  !
  YRECFM='SWA_GD'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Sdown absorbed by GARDEN areas'//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_GARDEN(:),IRESP,HCOMMENT=YCOMMENT)
  !
  YRECFM='LWA_GD'
  YRECFM=ADJUSTL(YPATCH//YRECFM)
  YCOMMENT='Ldown absorbed by GARDEN areas'//' (W/m2)'
  !
  CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_GARDEN(:),IRESP,HCOMMENT=YCOMMENT)
  !
ENDIF
!
YRECFM='REF_SW_GO'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Total solar rad reflected by ground '//' (W/m2)'
 CALL WRITE_SURF(HPROGRAM,YRECFM,XREF_SW_GRND(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LWE_GO'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='LW emitted by ground'//' (W/m2)'
 CALL WRITE_SURF(HPROGRAM,YRECFM,XEMIT_LW_GRND(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='REF_SW_FA'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='Total solar rad reflected by facade '//' (W/m2)'
 CALL WRITE_SURF(HPROGRAM,YRECFM,XREF_SW_FAC(:),IRESP,HCOMMENT=YCOMMENT)
!
YRECFM='LWE_FA'
YRECFM=ADJUSTL(YPATCH//YRECFM)
YCOMMENT='LW emitted by facade'//' (W/m2)'
 CALL WRITE_SURF(HPROGRAM,YRECFM,XEMIT_LW_FAC(:),IRESP,HCOMMENT=YCOMMENT)
!
!
  IF (CBEM=='BEM') THEN
    !
    YRECFM='XFLX_BLD'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='heat flux from bld'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XFLX_BLD(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='H_BLD_CL'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='sensible cooling demand'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XH_BLD_COOL(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='T_BLD_CL'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Total cooling demand'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XT_BLD_COOL(:),IRESP,HCOMMENT=YCOMMENT)
    !  
    YRECFM='H_BLD_HT'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='sensible heating demand'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XH_BLD_HEAT(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='LE_BLD_CL'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='latent cooling demand'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_BLD_COOL(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='LE_BLD_HT'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='latent heating demand'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_BLD_HEAT(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='H_WASTE'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='sensible waste heat from HVAC'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XH_WASTE(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='LE_WASTE'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='latent waste heat from HVAC'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_WASTE(:),IRESP,HCOMMENT=YCOMMENT)  
    !
    YRECFM='HVAC_CL'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='cooling energy consumption'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XHVAC_COOL(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='HVAC_HT'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='heating energy consumption'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XHVAC_HEAT(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='CAP_SYS'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Actual capacity of the cooling system'//' (W m-2(bld))'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XCAP_SYS(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='M_SYS'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Actual HVAC mass flow rate'//' (kg s-1 m-2(bld))'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XM_SYS(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='COP'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Actual COP of the cooling system'//' ()'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XCOP(:),IRESP,HCOMMENT=YCOMMENT)  
    !
    YRECFM='Q_SYS'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Supply air specific humidity'//' (kg kg-1)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XQ_SYS(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='T_SYS'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Supply air temperature'//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XT_SYS(:),IRESP,HCOMMENT=YCOMMENT)  
    !
    YRECFM='TR_SW_WIN'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Solar radiation transmitted through windows'//' (W m-2(bld))'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XTR_SW_WIN(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='FAN_POWER'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='HVAC fan power'//' (W m-2(bld))'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XFAN_POWER(:),IRESP,HCOMMENT=YCOMMENT)  
    !
    YRECFM='T_RAD_IND'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Indoor mean radiant temperature'//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XT_RAD_IND(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='HU_BLD'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Indoor relative humidity'//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XHU_BLD(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='SWA_WIN'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Sdown absorbed by windows'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_WIN(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='LWA_WIN'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Ldown absorbed by windows'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_WIN(:),IRESP,HCOMMENT=YCOMMENT)    
    !
  ENDIF
  !
  IF (LGREENROOF) THEN
  !
    YRECFM='RN_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='net radiation for GREENROOFs'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XRN_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='H_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='sensible heat flux for GREENROOFs'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XH_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='LE_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='latent heat flux for GREENROOFs'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XLE_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='GFLUX_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='net conduction flux for GREENROOFs'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XGFLUX_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='SWA_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Sdown absorbed by GREENROOFs'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_SW_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='LWA_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='Ldown absorbed by GREENROOFs'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XABS_LW_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='G_GR_ROOF'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='heat flux between GREENROOF and ROOF'//' (W/m2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XG_GREENROOF_ROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='RUNOFF_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='GREENROOF soil surface runoff'//' (kg/m2/s)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XRUNOFF_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
    !
    YRECFM='DRAIN_GR'
    YRECFM=ADJUSTL(YPATCH//YRECFM)
    YCOMMENT='GREENROOF total vertical drainage'//' (kg/m2/s)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XDRAIN_GREENROOF(:),IRESP,HCOMMENT=YCOMMENT)
  !
  ENDIF
  !
END IF
!
!*       5.    Cumulated Energy fluxes 
!
!
!-------------------------------------------------------------------------------
!
!         End of IO
!
 CALL END_IO_SURF_n(HPROGRAM)
IF (LHOOK) CALL DR_HOOK('WRITE_DIAG_MISC_TEB_N',1,ZHOOK_HANDLE)
!
END SUBROUTINE WRITE_DIAG_MISC_TEB_n
