!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
      SUBROUTINE WRITESURF_PGD_TEB_PAR_n(HPROGRAM)
!     ################################################
!
!!****  *WRITESURF_PGD_TEB_PAR_n* - reads ISBA physiographic fields
!!                        
!!
!!    PURPOSE
!!    -------
!!
!!**  METHOD
!!    ------
!!
!!    EXTERNAL
!!    --------
!!
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!	V. Masson   *Meteo France*	
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    05/2005
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_TEB_n,               ONLY : LGARDEN, LGREENROOF, CBEM
USE MODD_DATA_TEB_n,          ONLY : NPAR_ROAD_LAYER, NPAR_WALL_LAYER,               &
                                     NPAR_ROOF_LAYER,                                &
                                     NPAR_BLDTYPE, NPAR_BLD_AGE, NPAR_USETYPE,       &
                                     XPAR_Z0_TOWN, XPAR_BLD,                         &
                                     XPAR_GARDEN, XPAR_ROAD_DIR, XPAR_GREENROOF,     &
                                     XPAR_ALB_ROOF,                                  &
                                     XPAR_EMIS_ROOF, XPAR_HC_ROOF, XPAR_TC_ROOF,     &
                                     XPAR_D_ROOF, XPAR_ALB_ROAD, XPAR_EMIS_ROAD,     &
                                     XPAR_HC_ROAD, XPAR_TC_ROAD, XPAR_D_ROAD,        &
                                     XPAR_ALB_WALL, XPAR_EMIS_WALL, XPAR_HC_WALL,    &
                                     XPAR_TC_WALL, XPAR_D_WALL, XPAR_BLD_HEIGHT,     &
                                     XPAR_WALL_O_HOR,                                &
                                     XPAR_H_TRAFFIC, XPAR_LE_TRAFFIC,                &
                                     XPAR_H_INDUSTRY, XPAR_LE_INDUSTRY,              &
                                     LDATA_Z0_TOWN, LDATA_BLD, LDATA_ALB_ROOF,       &
                                     LDATA_EMIS_ROOF, LDATA_HC_ROOF, LDATA_TC_ROOF,  &
                                     LDATA_D_ROOF, LDATA_ALB_ROAD, LDATA_EMIS_ROAD,  &
                                     LDATA_HC_ROAD, LDATA_TC_ROAD, LDATA_D_ROAD,     &
                                     LDATA_ALB_WALL, LDATA_EMIS_WALL, LDATA_HC_WALL, &
                                     LDATA_TC_WALL, LDATA_D_WALL, LDATA_BLD_HEIGHT,  &
                                     LDATA_WALL_O_HOR,                               &
                                     LDATA_H_TRAFFIC, LDATA_LE_TRAFFIC,              &
                                     LDATA_H_INDUSTRY, LDATA_LE_INDUSTRY ,           &
                                     LDATA_GARDEN, LDATA_BLDTYPE, LDATA_GREENROOF,   &
                                     LDATA_ROAD_DIR, LDATA_USETYPE, LDATA_BLD_AGE,   &
                                     LDATA_ROUGH_ROOF, LDATA_ROUGH_WALL,             &
                                     XPAR_ROUGH_ROOF, XPAR_ROUGH_WALL
USE MODD_DATA_BEM_n,          ONLY : NPAR_FLOOR_LAYER,                               &
                                     XPAR_HC_FLOOR, XPAR_TC_FLOOR, XPAR_D_FLOOR,     &
                                     XPAR_TCOOL_TARGET, XPAR_THEAT_TARGET,           &
                                     XPAR_F_WASTE_CAN,                               &
                                     XPAR_EFF_HEAT, XPAR_QIN, XPAR_QIN_FRAD,         &
                                     XPAR_SHGC, XPAR_U_WIN, XPAR_GR, XPAR_SHGC_SH,   &
                                     XPAR_FLOOR_HEIGHT, XPAR_INF, XPAR_QIN_FLAT,     &
                                     XPAR_HR_TARGET, XPAR_V_VENT, XPAR_CAP_SYS_HEAT, &
                                     XPAR_CAP_SYS_RAT, XPAR_T_ADP, XPAR_M_SYS_RAT,   &
                                     XPAR_COP_RAT, XPAR_T_SIZE_MAX, XPAR_T_SIZE_MIN, &
                                     XPAR_F_WATER_COND, XPAR_NATVENT, XPAR_SHADE,    &
                                     LDATA_TCOOL_TARGET, LDATA_THEAT_TARGET,         &
                                     LDATA_F_WASTE_CAN, LDATA_EFF_HEAT, LDATA_QIN,   &
                                     LDATA_QIN_FRAD, LDATA_SHGC, LDATA_U_WIN,        &
                                     LDATA_GR, LDATA_FLOOR_HEIGHT, LDATA_INF,        &
                                     LDATA_QIN_FLAT, LDATA_HR_TARGET, LDATA_V_VENT,  &
                                     LDATA_CAP_SYS_HEAT, LDATA_CAP_SYS_RAT,          &
                                     LDATA_T_ADP, LDATA_M_SYS_RAT, LDATA_COP_RAT,    &
                                     LDATA_T_SIZE_MAX, LDATA_T_SIZE_MIN,             &
                                     LDATA_NATVENT, LDATA_SHGC_SH,                   &
                                     LDATA_F_WATER_COND, LDATA_SHADE, LDATA_HC_FLOOR,&
                                     LDATA_TC_FLOOR, LDATA_D_FLOOR

USE MODD_TEB_GARDEN_n,        ONLY : CTYPE_HVEG, CTYPE_LVEG, CTYPE_NVEG, LPAR_GARDEN
USE MODD_DATA_TEB_GARDEN_n,   ONLY : NTIME,                                          &
                                     XDATA_FRAC_HVEG, XDATA_FRAC_LVEG,               &
                                     XDATA_FRAC_NVEG,                                &
                                     XDATA_LAI_HVEG , XDATA_LAI_LVEG ,               &
                                     XDATA_H_HVEG  
USE MODD_TEB_GREENROOF_n,     ONLY : NTIME_GR,NLAYER_GR,CTYP_GR, LPAR_GREENROOF
USE MODD_DATA_TEB_GREENROOF_n,ONLY : XPAR_OM_GR, XPAR_CLAY_GR,                       &
                                     XPAR_SAND_GR, XPAR_LAI_GR
!
USE MODI_WRITE_SURF
USE MODI_WRITE_BLD_DESCRIPTION
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
!
 CHARACTER(LEN=6),  INTENT(IN)  :: HPROGRAM ! program calling
!
!*       0.2   Declarations of local variables
!              -------------------------------
!
INTEGER           :: IRESP          ! IRESP  : return-code if a problem appears
 CHARACTER(LEN=12) :: YRECFM         ! Name of the article to be read
 CHARACTER(LEN=100):: YCOMMENT       ! Comment string
INTEGER           :: JLAYER         ! loop index
INTEGER           :: JTIME          ! loop index
REAL, DIMENSION(:), ALLOCATABLE :: ZWORK
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!-------------------------------------------------------------------------------
!
IF (LHOOK) CALL DR_HOOK('WRITESURF_PGD_TEB_PAR_N',0,ZHOOK_HANDLE)
YRECFM='L_BLDTYPE'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_BLDTYPE,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_BLDTYPE) THEN
  YRECFM='D_BLDTYPE'
  YCOMMENT='X_Y_'//YRECFM//' (m)'
  ALLOCATE(ZWORK(SIZE(NPAR_BLDTYPE)))
  ZWORK=FLOAT(NPAR_BLDTYPE(:))
  CALL WRITE_SURF(HPROGRAM,YRECFM,ZWORK,IRESP,YCOMMENT)
  DEALLOCATE(ZWORK)
ENDIF
!
YRECFM='L_BLD_AGE'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_BLD_AGE,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_BLD_AGE) THEN
  YRECFM='D_BLD_AGE'
  YCOMMENT='X_Y_'//YRECFM//' (m)'
  ALLOCATE(ZWORK(SIZE(NPAR_BLD_AGE)))
  ZWORK=FLOAT(NPAR_BLD_AGE(:))
  CALL WRITE_SURF(HPROGRAM,YRECFM,ZWORK,IRESP,YCOMMENT)
  DEALLOCATE(ZWORK)
ENDIF
!
YRECFM='L_USETYPE'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_USETYPE,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_USETYPE) THEN
  YRECFM='D_USETYPE'
  YCOMMENT='X_Y_'//YRECFM//' (m)'
  ALLOCATE(ZWORK(SIZE(NPAR_USETYPE)))
  ZWORK=FLOAT(NPAR_USETYPE(:))
  CALL WRITE_SURF(HPROGRAM,YRECFM,ZWORK,IRESP,YCOMMENT)
  DEALLOCATE(ZWORK)
ENDIF
!
IF (LDATA_BLDTYPE .OR. LDATA_BLD_AGE .OR. LDATA_USETYPE) CALL WRITE_BLD_DESCRIPTION(HPROGRAM)
!
YRECFM='L_Z0_TOWN'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_Z0_TOWN,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_Z0_TOWN) THEN
  YRECFM='D_Z0_TOWN'
  YCOMMENT='X_Y_'//YRECFM//' (m)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_Z0_TOWN,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_BLD'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_BLD,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_BLD) THEN
  YRECFM='D_BLD'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_BLD,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_GARDEN'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_GARDEN,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_GARDEN) THEN
  YRECFM='D_GARDEN'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_GARDEN,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_GREENROOF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_GREENROOF,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_GREENROOF) THEN
  YRECFM='D_GREENROOF'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_GREENROOF,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_ROAD_DIR'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_ROAD_DIR,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_ROAD_DIR) THEN
  YRECFM='D_ROAD_DIR'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_ROAD_DIR,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_ALB_ROOF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_ALB_ROOF,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_ALB_ROOF) THEN
  YRECFM='D_ALB_ROOF'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_ALB_ROOF,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_EMIS_ROOF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_EMIS_ROOF,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_EMIS_ROOF) THEN
  YRECFM='D_EMI_ROOF'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_EMIS_ROOF,IRESP,YCOMMENT)
ENDIF
!
IF (LDATA_HC_ROOF) THEN
  YCOMMENT='Number of specified Roof thermal layers'
  CALL WRITE_SURF(HPROGRAM,'PAR_RF_LAYER',NPAR_ROOF_LAYER,IRESP,YCOMMENT)
END IF
!
YRECFM='L_HC_ROOF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_HC_ROOF,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_HC_ROOF) THEN
  DO JLAYER=1,NPAR_ROOF_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_HC_ROOF',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (J/K/m3)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_HC_ROOF(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_TC_ROOF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_TC_ROOF,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_TC_ROOF) THEN
  DO JLAYER=1,NPAR_ROOF_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_TC_ROOF',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (W/K/m)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_TC_ROOF(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_D_ROOF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_D_ROOF,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_D_ROOF) THEN
  DO JLAYER=1,NPAR_ROOF_LAYER
    WRITE(YRECFM,FMT='(A8,I1.1)') 'D_D_ROOF',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (m)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_D_ROOF(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_ALB_ROAD'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_ALB_ROAD,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_ALB_ROAD) THEN
  YRECFM='D_ALB_ROAD'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_ALB_ROAD,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_EMIS_ROAD'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_EMIS_ROAD,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_EMIS_ROAD) THEN
  YRECFM='D_EMI_ROAD'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_EMIS_ROAD,IRESP,YCOMMENT)
ENDIF
!
IF (LDATA_HC_ROAD) THEN
  YCOMMENT='Number of specified Road thermal layers'
  CALL WRITE_SURF(HPROGRAM,'PAR_RD_LAYER',NPAR_ROAD_LAYER,IRESP,YCOMMENT)
END IF
!
YRECFM='L_HC_ROAD'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_HC_ROAD,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_HC_ROAD) THEN
  DO JLAYER=1,NPAR_ROAD_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_HC_ROAD',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (J/K/m3)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_HC_ROAD(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_TC_ROAD'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_TC_ROAD,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_TC_ROAD) THEN
  DO JLAYER=1,NPAR_ROAD_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_TC_ROAD',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (W/K/m)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_TC_ROAD(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_D_ROAD'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_D_ROAD,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_D_ROAD) THEN
  DO JLAYER=1,NPAR_ROAD_LAYER
    WRITE(YRECFM,FMT='(A8,I1.1)') 'D_D_ROAD',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (m)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_D_ROAD(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_ALB_WALL'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_ALB_WALL,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_ALB_WALL) THEN
  YRECFM='D_ALB_WALL'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_ALB_WALL,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_EMIS_WALL'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_EMIS_WALL,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_EMIS_WALL) THEN
  YRECFM='D_EMI_WALL'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_EMIS_WALL,IRESP,YCOMMENT)
ENDIF
!
!
IF (LDATA_HC_WALL) THEN
  YCOMMENT='Number of specified Wall thermal layers'
  CALL WRITE_SURF(HPROGRAM,'PAR_WL_LAYER',NPAR_WALL_LAYER,IRESP,YCOMMENT)
END IF
!
YRECFM='L_HC_WALL'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_HC_WALL,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_HC_WALL) THEN
  DO JLAYER=1,NPAR_WALL_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_HC_WALL',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (J/K/m3)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_HC_WALL(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_TC_WALL'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_TC_WALL,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_TC_WALL) THEN
  DO JLAYER=1,NPAR_WALL_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_TC_WALL',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (W/K/m)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_TC_WALL(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_D_WALL'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_D_WALL,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_D_WALL) THEN
  DO JLAYER=1,NPAR_WALL_LAYER
    WRITE(YRECFM,FMT='(A8,I1.1)') 'D_D_WALL',JLAYER
    YCOMMENT='X_Y_'//YRECFM//' (m)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_D_WALL(:,JLAYER),IRESP,YCOMMENT)
  END DO
ENDIF
!
YRECFM='L_BLD_HEIGHT'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_BLD_HEIGHT,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_BLD_HEIGHT) THEN
  YRECFM='D_BLD_HEIG'
  YCOMMENT='X_Y_'//YRECFM//' (m)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_BLD_HEIGHT,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_WALL_O_HOR'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_WALL_O_HOR,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_WALL_O_HOR) THEN
  YRECFM='D_WALL_O_H'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_WALL_O_HOR,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_H_TRAF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_H_TRAFFIC,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_H_TRAFFIC) THEN
  YRECFM='D_H_TRAF'
  YCOMMENT='X_Y_'//YRECFM//' (W/m2)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_H_TRAFFIC,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_LE_TRAF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_LE_TRAFFIC,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_LE_TRAFFIC) THEN
  YRECFM='D_LE_TRAF'
  YCOMMENT='X_Y_'//YRECFM//' (W/m2)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_LE_TRAFFIC,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_H_IND'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_H_INDUSTRY,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_H_INDUSTRY) THEN
  YRECFM='D_H_IND'
  YCOMMENT='X_Y_'//YRECFM//' (W/m2)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_H_INDUSTRY,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_LE_IND'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_LE_INDUSTRY,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_LE_INDUSTRY) THEN
  YRECFM='D_LE_IND'
  YCOMMENT='X_Y_'//YRECFM//' (W/m2)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_LE_INDUSTRY,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_ROUGH_ROOF'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_ROUGH_ROOF,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_ROUGH_ROOF) THEN
  YRECFM='D_ROUGH_ROOF'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_ROUGH_ROOF,IRESP,YCOMMENT)
ENDIF
!
YRECFM='L_ROUGH_WALL'
YCOMMENT=YRECFM
 CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_ROUGH_WALL,IRESP,HCOMMENT=YCOMMENT)
IF (LDATA_ROUGH_WALL) THEN
  YRECFM='D_ROUGH_WALL'
  YCOMMENT='X_Y_'//YRECFM//' (-)'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_ROUGH_WALL,IRESP,YCOMMENT)
ENDIF
IF (CBEM .EQ. 'BEM') THEN
  !
  IF (LDATA_HC_FLOOR) THEN
    YCOMMENT='Number of specified Floor thermal layers'
    CALL WRITE_SURF(HPROGRAM,'PAR_FL_LAYER',NPAR_FLOOR_LAYER,IRESP,YCOMMENT)
  END IF
  !
  YRECFM='L_HC_FLOOR'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_HC_FLOOR,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_HC_FLOOR) THEN
    DO JLAYER=1,NPAR_FLOOR_LAYER
      WRITE(YRECFM,FMT='(A10,I1.1)') 'D_HC_FLOOR',JLAYER
      YCOMMENT='X_Y_'//YRECFM//' (J/K/m3)'
      CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_HC_FLOOR(:,JLAYER),IRESP,YCOMMENT)
    END DO
  ENDIF
  !
  YRECFM='L_TC_FLOOR'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_TC_FLOOR,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_TC_FLOOR) THEN
    DO JLAYER=1,NPAR_FLOOR_LAYER
      WRITE(YRECFM,FMT='(A10,I1.1)') 'D_TC_FLOOR',JLAYER
      YCOMMENT='X_Y_'//YRECFM//' (W/K/m)'
      CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_TC_FLOOR(:,JLAYER),IRESP,YCOMMENT)
    END DO
  ENDIF
  !
  YRECFM='L_D_FLOOR'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_D_FLOOR,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_D_FLOOR) THEN
    DO JLAYER=1,NPAR_FLOOR_LAYER
      WRITE(YRECFM,FMT='(A9,I1.1)') 'D_D_FLOOR',JLAYER
      YCOMMENT='X_Y_'//YRECFM//' (m)'
      CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_D_FLOOR(:,JLAYER),IRESP,YCOMMENT)
    END DO
  ENDIF
  !
  YRECFM='L_TCOOL_TARG'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_TCOOL_TARGET,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_TCOOL_TARGET) THEN
    YRECFM='D_TCOOL_TARG'
    YCOMMENT='X_Y_'//YRECFM//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_TCOOL_TARGET,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_THEAT_TARG'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_THEAT_TARGET,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_THEAT_TARGET) THEN
    YRECFM='D_THEAT_TARG'
    YCOMMENT='X_Y_'//YRECFM//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_THEAT_TARGET,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_F_WAST_CAN'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_F_WASTE_CAN,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_F_WASTE_CAN) THEN
    YRECFM='D_F_WAST_CAN'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_F_WASTE_CAN,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_EFF_HEAT'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_EFF_HEAT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_EFF_HEAT) THEN
    YRECFM='D_EFF_HEAT'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_EFF_HEAT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_QIN'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_QIN,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_QIN) THEN
    YRECFM='D_QIN'
    YCOMMENT='X_Y_'//YRECFM//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_QIN,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_QIN_FRAD'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_QIN_FRAD,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_QIN_FRAD) THEN
    YRECFM='D_QIN_FRAD'
    YCOMMENT='X_Y_'//YRECFM//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_QIN_FRAD,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_SHGC'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_SHGC,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_SHGC) THEN
    YRECFM='D_SHGC'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_SHGC,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_U_WIN'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_U_WIN,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_U_WIN) THEN
    YRECFM='D_U_WIN'
    YCOMMENT='X_Y_'//YRECFM//' (W m-2 K-1)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_U_WIN,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_GR'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_GR,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_GR) THEN
    YRECFM='D_GR'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_GR,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_SHGC_SH'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_SHGC_SH,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_SHGC_SH) THEN
    YRECFM='D_SHGC_SH'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_SHGC_SH,IRESP,YCOMMENT)
  ENDIF  
  !
  YRECFM='L_FLOOR_HEIG'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_FLOOR_HEIGHT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_FLOOR_HEIGHT) THEN
    YRECFM='D_FLOOR_HEIG'
    YCOMMENT='X_Y_'//YRECFM//' (m)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_FLOOR_HEIGHT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_INF'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_INF,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_INF) THEN
    YRECFM='D_INF'
    YCOMMENT='X_Y_'//YRECFM//' (ACH)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_INF,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_QIN_FLAT'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_QIN_FLAT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_QIN_FLAT) THEN
    YRECFM='D_QIN_FLAT'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_QIN_FLAT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_HR_TARGET'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_HR_TARGET,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_HR_TARGET) THEN
    YRECFM='D_HR_TARGET'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_HR_TARGET,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_V_VENT'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_V_VENT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_V_VENT) THEN
    YRECFM='D_V_VENT'
    YCOMMENT='X_Y_'//YRECFM//' (ACH)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_V_VENT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_CAP_SYS_HE'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_CAP_SYS_HEAT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_CAP_SYS_HEAT) THEN
    YRECFM='D_CAP_SYS_HE'
    YCOMMENT='X_Y_'//YRECFM//' (W m-2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_CAP_SYS_HEAT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_CAP_SYS_RA'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_CAP_SYS_RAT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_CAP_SYS_RAT) THEN
    YRECFM='D_CAP_SYS_RA'
    YCOMMENT='X_Y_'//YRECFM//' (W m-2)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_CAP_SYS_RAT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_T_ADP'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_T_ADP,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_T_ADP) THEN
    YRECFM='D_T_ADP'
    YCOMMENT='X_Y_'//YRECFM//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_T_ADP,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_M_SYS_RAT'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_M_SYS_RAT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_M_SYS_RAT) THEN
    YRECFM='D_M_SYS_RAT'
    YCOMMENT='X_Y_'//YRECFM//' (kg s-1 m-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_M_SYS_RAT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_COP_RAT'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_COP_RAT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_COP_RAT) THEN
    YRECFM='D_COP_RAT'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_COP_RAT,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_T_SIZE_MAX'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_T_SIZE_MAX,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_T_SIZE_MAX) THEN
    YRECFM='D_T_SIZE_MAX'
    YCOMMENT='X_Y_'//YRECFM//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_T_SIZE_MAX,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_T_SIZE_MIN'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_T_SIZE_MIN,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_T_SIZE_MIN) THEN
    YRECFM='D_T_SIZE_MIN'
    YCOMMENT='X_Y_'//YRECFM//' (K)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_T_SIZE_MIN,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_FWAT_COND'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_F_WATER_COND,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_F_WATER_COND) THEN
    YRECFM='D_FWAT_COND'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_F_WATER_COND,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_SHADE'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_SHADE,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_SHADE) THEN
    YRECFM='D_SHADE'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_SHADE,IRESP,YCOMMENT)
  ENDIF
  !
  YRECFM='L_NATVENT'
  YCOMMENT=YRECFM
  CALL WRITE_SURF(HPROGRAM,YRECFM,LDATA_NATVENT,IRESP,HCOMMENT=YCOMMENT)
  IF (LDATA_NATVENT) THEN
    YRECFM='D_NATVENT'
    YCOMMENT='X_Y_'//YRECFM//' (-)'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_NATVENT,IRESP,YCOMMENT)
  ENDIF
  !  
ENDIF
!
! Flag for data for gardens
YRECFM='PAR_GARDEN'
YCOMMENT='FLAG FOR SPECIFIED GARDEN PARAMETERS'
 CALL WRITE_SURF(HPROGRAM,YRECFM,LPAR_GARDEN,IRESP,HCOMMENT=YCOMMENT)
!
IF (LGARDEN .AND. LPAR_GARDEN) THEN
!
! Type of high vegetation
  YRECFM='D_TYPE_HVEG'
  YCOMMENT='X_Y_TYPE_HVEG'
  CALL WRITE_SURF(HPROGRAM,YRECFM,CTYPE_HVEG,IRESP,HCOMMENT=YCOMMENT)
!
! Type of low vegetation
  YRECFM='D_TYPE_LVEG'
  YCOMMENT='X_Y_TYPE_LVEG'
  CALL WRITE_SURF(HPROGRAM,YRECFM,CTYPE_LVEG,IRESP,HCOMMENT=YCOMMENT)
!
! Type of bare soil (no vegetation)
  YRECFM='D_TYPE_NVEG'
  YCOMMENT='X_Y_TYPE_NVEG'
  CALL WRITE_SURF(HPROGRAM,YRECFM,CTYPE_NVEG,IRESP,HCOMMENT=YCOMMENT)
!
! Fraction of high vegetation
  YRECFM='D_FRAC_HVEG'
  YCOMMENT='X_Y_D_FRAC_HVEG'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XDATA_FRAC_HVEG(:),IRESP,HCOMMENT=YCOMMENT)
!
! Fraction of low vegetation
  YRECFM='D_FRAC_LVEG'
  YCOMMENT='X_Y_D_FRAC_LVEG'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XDATA_FRAC_LVEG(:),IRESP,HCOMMENT=YCOMMENT)
!
! Fraction of bare soil
  YRECFM='D_FRAC_NVEG'
  YCOMMENT='X_Y_D_FRAC_NVEG'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XDATA_FRAC_NVEG(:),IRESP,HCOMMENT=YCOMMENT)
!
! LAI of high vegetation
  DO JTIME=1,NTIME
    WRITE(YRECFM,FMT='(A10,I2.2)') 'D_LAI_HVEG',JTIME
    YCOMMENT='X_Y_D_LAI_HVEG'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XDATA_LAI_HVEG(:,JTIME),IRESP,HCOMMENT=YCOMMENT)
  END DO
!
! LAI of low vegetation
  DO JTIME=1,NTIME
    WRITE(YRECFM,FMT='(A10,I2.2)') 'D_LAI_LVEG',JTIME
    YCOMMENT='X_Y_D_LAI_LVEG'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XDATA_LAI_LVEG(:,JTIME),IRESP,HCOMMENT=YCOMMENT)
  END DO
!
! Height of trees
  YRECFM='D_H_HVEG'
  YCOMMENT='X_Y_DATA_H_HVEG'
  CALL WRITE_SURF(HPROGRAM,YRECFM,XDATA_H_HVEG(:),IRESP,HCOMMENT=YCOMMENT)
!
ENDIF
!
IF (LGREENROOF .AND. LPAR_GREENROOF) THEN
!
! Type of green roof
  YRECFM='D_TYPE_GR'
  YCOMMENT='X_Y_TYPE_GR'
  CALL WRITE_SURF(HPROGRAM,YRECFM,CTYP_GR,IRESP,HCOMMENT=YCOMMENT)
!
! Fraction of OM in green roof layer
  DO JLAYER=1,NLAYER_GR
    WRITE(YRECFM,FMT='(A7,I2.2)') 'D_OM_GR',JLAYER
    YCOMMENT='X_Y_D_OM_GR'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_OM_GR(:,JLAYER),IRESP,HCOMMENT=YCOMMENT)
  END DO
!
! Fraction of CLAY in the non-OM part of the green roof layer
  DO JLAYER=1,NLAYER_GR
    WRITE(YRECFM,FMT='(A9,I2.2)') 'D_CLAY_GR',JLAYER
    YCOMMENT='X_Y_D_CLAY_GR'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_CLAY_GR(:,JLAYER),IRESP,HCOMMENT=YCOMMENT)
  END DO
!
! Fraction of SAND in the non-OM part of the green roof layer
  DO JLAYER=1,NLAYER_GR
    WRITE(YRECFM,FMT='(A9,I2.2)') 'D_SAND_GR',JLAYER
    YCOMMENT='X_Y_D_SAND_GR'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_SAND_GR(:,JLAYER),IRESP,HCOMMENT=YCOMMENT)
  END DO
!
! LAI of green roof vegetation
  DO JTIME=1,NTIME_GR
    WRITE(YRECFM,FMT='(A8,I2.2)') 'D_LAI_GR',JTIME
    YCOMMENT='X_Y_D_LAI_GR'
    CALL WRITE_SURF(HPROGRAM,YRECFM,XPAR_LAI_GR(:,JTIME),IRESP,HCOMMENT=YCOMMENT)
  END DO
! 
ENDIF
!
IF (LHOOK) CALL DR_HOOK('WRITESURF_PGD_TEB_PAR_N',1,ZHOOK_HANDLE)
!
!
!-------------------------------------------------------------------------------
!
END SUBROUTINE WRITESURF_PGD_TEB_PAR_n
